<template>
  <q-page class="flex flex-center proxy-app-page">
    <div class="q-pa-md row items-start q-gutter-md card-container">
      <div v-if="loading === true">
        <q-spinner-cube color="white" size="2em" />
      </div>
      <q-card v-for="slide in slides" :key="slide.id" class="job-card">
        <a :href="activatedLink" @click="checkActivedLink(slide.job.status)"
          @mouseover="setCurrentSlideURL(slide.view_url)" target="_blank" class="non-highlighted-link">
          <q-item>
            <q-item-section>
              <q-item-label>Slide {{ slide.id.split("-")[0] }}</q-item-label>
              <q-item-label caption>{{ slide.tissue.mappings.EN }} -
                {{ slide.stain.mappings.EN }}</q-item-label>
            </q-item-section>
            <q-item-section avatar>
              <q-tooltip anchor="center right" self="center left" :offset="[25, 0]">
                Job status: {{ slide.job.status }} <br>
                Created: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{ slide.job.created_at_str }} <br>
                Ended: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{ slide.job.ended_at_str }}
              </q-tooltip>
              <q-avatar>
                <q-btn v-if="slide.job.status === 'COMPLETED'" flat round color="green" icon="done" />
                <q-btn v-else-if="slide.job.status === 'FAILED' ||
                  slide.job.status === 'TIMEOUT' ||
                  slide.job.status === 'ERROR' ||
                  slide.job.status === 'INCOMPLETE'
                  " flat round color="red" icon="close" />
                <q-spinner-ios v-else color="gray" size="1em" />
              </q-avatar>
            </q-item-section>
          </q-item>
          <div style="width: 200px; height: 300px; text-align: center">
            <img v-if="slide.src" :src="slide.src" style="max-width: 200px; max-height: 300px">
            <div v-else style="
                display: flex;
                justify-content: center;
                align-items: center;
                width: 200px;
                height: 300px;
              ">
              <q-spinner-cube color="black" size="2em" />
            </div>
          </div>
        </a>
        <q-tooltip v-if="slide.view_url" anchor="top middle" self="bottom middle" :offset="[10, 10]"
          style="text-align: center;">
          Press {{ keyName }} key and click<br>
          to view in case on external platform
        </q-tooltip>
        <q-tooltip v-else anchor="top middle" self="bottom middle" :offset="[10, 10]" style="text-align: center">
          Job status: {{ slide.job.status }}<br />
          {{ slide.job.error_message }}
        </q-tooltip>
      </q-card>
    </div>
    <div v-if="slides.length === 0 && loading === false" style="color: white">
      There are currently no preprocessed slides
    </div>
  </q-page>
</template>

<script>
import { useQuasar } from 'quasar'
import { watch, defineComponent, ref } from "vue";
import {
  addScopeListener,
  addTokenListener,
  addWbsUrlListener,
  requestNewToken,
} from "@empaia/vendor-app-communication-interface";

export default defineComponent({
  name: "IndexPage",
  setup() {
    const wbsUrl = ref("");
    const scopeId = ref("");
    const accessToken = ref("");
    const slides = ref([]);
    const jobs = ref([]);
    const loading = ref(true);
    const currentSlideURL = ref("")
    const activatedLink = ref("javascript: void(0)")

    const setCurrentSlideURL = function (view_url) {
      currentSlideURL.value = view_url
    }

    const $q = useQuasar()
    let keyName = "CTRL"
    if ($q.platform.is.mac) {
      keyName = "COMMAND"
    }
    const checkActivedLink = function (status) {
      if (activatedLink.value === "javascript: void(0)") {
        if (status === "COMPLETED") {
          $q.notify({
            message: `Please press the <b>${keyName}</b> key while clicking a slide`,
            timeout: 2000,
            icon: 'error',
            html: true,
            badgeStyle: "opacity: 0"
          })
        }
      }
    }

    addWbsUrlListener(function (x) {
      wbsUrl.value = x.url;
    });

    addScopeListener(function (x) {
      scopeId.value = x.id;
    });

    addTokenListener(function (x) {
      accessToken.value = x.value;
    });

    watch([wbsUrl, scopeId, accessToken], () => {
      if (
        scopeId.value !== "" &&
        accessToken.value !== "" &&
        wbsUrl.value !== "" &&
        slides.value.length == 0
      ) {
        // slides
        const xhr_slides = new XMLHttpRequest();
        let _slides = [];
        xhr_slides.open(
          "GET",
          `${wbsUrl.value}/v3/scopes/${scopeId.value}/slides`,
          true
        );
        xhr_slides.setRequestHeader(
          "Authorization",
          `Bearer ${accessToken.value}`
        );
        xhr_slides.setRequestHeader("Content-Type", "application/json");
        xhr_slides.onreadystatechange = function () {
          if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
            _slides = JSON.parse(this.responseText).items;
            for (const slide of _slides) {
              slide.job = {};
            }
          }
        };
        xhr_slides.send();
        // jobs
        const xhr_jobs = new XMLHttpRequest();
        xhr_jobs.open(
          "GET",
          `${wbsUrl.value}/v3/scopes/${scopeId.value}/jobs`,
          true
        );
        xhr_jobs.setRequestHeader(
          "Authorization",
          `Bearer ${accessToken.value}`
        );
        xhr_jobs.setRequestHeader("Content-Type", "application/json");
        xhr_jobs.onreadystatechange = function () {
          if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
            jobs.value = JSON.parse(this.responseText).items;
            const processedSlideIds = []
            for (const job of jobs.value) {
              processedSlideIds.push(job.inputs.slide)
            }
            if (jobs.value.length > 0) {
              _slides = _slides.filter((slide) => processedSlideIds.includes(slide.id))
              _slides = _slides.filter((slide) => !slide.deleted)
              slides.value = _slides;
            }
            loading.value = false;
          }
        };
        xhr_jobs.send();
      }
    });

    const convertUnixTimestamp = function (unixTimestamp) {
      if (unixTimestamp) {
        const timestampInMillis = unixTimestamp * 1000;
        const date = new Date(timestampInMillis);
        const year = date.getFullYear();
        const month = String(date.getMonth() + 1).padStart(2, '0');
        const day = String(date.getDate()).padStart(2, '0');
        const hours = String(date.getHours()).padStart(2, '0');
        const minutes = String(date.getMinutes()).padStart(2, '0');
        const seconds = String(date.getSeconds()).padStart(2, '0');
        return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
      } else {
        return '-'
      }
    }

    const updateViewUrl = function (slide) {
      const xhr_output = new XMLHttpRequest();
      if (slide.job.outputs) {
        const view_url_id = slide.job.outputs.view_url;
        if (view_url_id !== undefined) {
          xhr_output.open(
            "GET",
            `${wbsUrl.value}/v3/scopes/${scopeId.value}/primitives/${view_url_id}`,
            true
          );
          xhr_output.setRequestHeader(
            "Authorization",
            `Bearer ${accessToken.value}`
          );
          xhr_output.setRequestHeader("Content-Type", "application/json");
          xhr_output.onreadystatechange = function () {
            if (
              this.readyState === XMLHttpRequest.DONE &&
              this.status === 200
            ) {
              const view_url = JSON.parse(this.responseText);
              slide.view_url = view_url.value;
            }
          };
          xhr_output.send();
        }
      }
    }

    watch([jobs, slides], () => {
      if (jobs.value.length > 0 && slides.value.length > 0) {
        for (const slide of slides.value) {
          // find latest job for slide
          let latest_time = 0;
          for (const job of jobs.value) {
            job.created_at_str = convertUnixTimestamp(job.created_at)
            job.ended_at_str = convertUnixTimestamp(job.ended_at)
            if (slide.id === job.inputs.slide && job.created_at > latest_time) {
              slide.job = job;
              latest_time = job.created_at;
            }
          }
          // slide thumbnail
          const xhr_slide = new XMLHttpRequest();
          xhr_slide.open(
            "GET",
            `${wbsUrl.value}/v3/scopes/${scopeId.value}/slides/${slide.id}/thumbnail/max_size/300/300`,
            true
          );
          xhr_slide.setRequestHeader(
            "Authorization",
            `Bearer ${accessToken.value}`
          );
          xhr_slide.responseType = "arraybuffer";
          xhr_slide.onreadystatechange = function () {
            if (
              this.readyState === XMLHttpRequest.DONE &&
              this.status === 200
            ) {
              var blob = new Blob([this.response], { type: "image/jpeg" });
              slide.src = URL.createObjectURL(blob);
            }
          };
          xhr_slide.send();
          // view url
          updateViewUrl(slide)
        }
      }
    });

    document.addEventListener('keydown', function (event) {
      if (keyName === "COMMAND") {
        if (event.key === "Meta") {
          activatedLink.value = currentSlideURL.value
        }
      }
      if (keyName === "CTRL") {
        if (event.key === "Control") {
          activatedLink.value = currentSlideURL.value
        }
      }
    });

    document.addEventListener('keyup', function (event) {
      if (keyName === "COMMAND") {
        if (event.key === "Meta") {
          activatedLink.value = "javascript: void(0)"
        }
      }
      if (keyName === "CTRL") {
        if (event.key === "Control") {
          activatedLink.value = "javascript: void(0)"
        }
      }
    });

    setInterval(function () {
      requestNewToken();
    }, 60000);

    setInterval(function () {
      const states = ["NONE", "ASSEMBLY", "READY", "SCHEDULED", "RUNNING"]
      if (jobs.value.length > 0 && slides.value.length > 0) {
        for (const slide of slides.value) {
          if (slide.job && states.includes(slide.job.status)) {
            // update job
            const xhr_job = new XMLHttpRequest();
            xhr_job.open(
              "GET",
              `${wbsUrl.value}/v3/scopes/${scopeId.value}/jobs/${slide.job.id}`,
              true
            );
            xhr_job.setRequestHeader(
              "Authorization",
              `Bearer ${accessToken.value}`
            );
            xhr_job.setRequestHeader("Content-Type", "application/json");
            xhr_job.onreadystatechange = function () {
              if (this.readyState === XMLHttpRequest.DONE && this.status === 200) {
                slide.job = JSON.parse(this.responseText)
                slide.job.created_at_str = convertUnixTimestamp(slide.job.created_at)
                slide.job.ended_at_str = convertUnixTimestamp(slide.job.ended_at)
                updateViewUrl(slide)
              }
            };
            xhr_job.send();
          }
        }
      }
    }, 10000);

    return {
      wbsUrl,
      scopeId,
      accessToken,
      slides,
      jobs,
      loading,
      currentSlideURL,
      setCurrentSlideURL,
      activatedLink,
      checkActivedLink,
      keyName
    };
  },
});
</script>

<style lang="css" scoped>
.proxy-app-page {
  background-color: #1c1c21;
}

.card-container {
  margin-left: 10px;
}

.job-card {
  width: 100%;
  max-width: 200px;
}

.job-card:hover {
  box-shadow: 0 0 5px #fff;
}

.non-highlighted-link {
  text-decoration: none;
  color: inherit;
}

.non-highlighted-link:hover {
  text-decoration: none;
  color: inherit;
}

.key {
  display: inline-block;
  padding: 2px 6px;
  margin: 2px;
  border: 1px solid #aaa;
  border-radius: 4px;
  box-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);
  background-color: #f7f7f7;
  font: 11px/1 'Arial', sans-serif;
  color: #333;
}
</style>
